---
published: true
taxonomy:
    category: [info]
    tag: [zp]
    author: Daniel Hladek
---
# Často kladené otázky

## Pre koho to je?

Stránka je určená pre študentov a vyučujúcich na Katedre elektroniky a multimediálnych telekomunikácií pre zdieľanie výsledkov záverečných prác.
Pomôže aj záujemcom o štúdium, zamestnávateľom a partnerom katedry na získanie prehľadu o študentskej odbornej činnosti.

## Ako to funguje

Stránka je založená na princípe WIKI - každý prihlásený použvateľ môže zapisovať na ľubovoľné miesto. Každá zmena aj jej autor sa ale zaznamenáva pomocou [systému GIT](https://git.kemt.fei.tuke.sk). Je jednoduché zistiť, kto urobil kedy akú zmenu a zmenu zvrátiť.

Stránky môžte editovať cez web rozhranie systému  alebo lokálne pomocou Vášho obľúbeného textového editora a synchronizovať pomocou príkazu `git`. Jedna stránka zodpovedá jednému adresáru. Do adresáru  umiestnite text stránky vo formáte Markdown do súboru `README.md` a ostatné súvisiace súbory, napr. obrázky.

## Čo tu nájdem?

Nájdete tu materiály súvisiace s vypracovaním záverečnej práce.

- `/home` : Domovská stránka
- `/teachers`:  Projekty pod vedením pedagógov (zapisuje hlavne pedagog).
- `/topics`: Iné informácie (Zapisujú hlavne pedagógovia)
- `/students`:  Študentské výstupy (Zapisuje hlavne študent)

Každý prihlásený používateľ ma svoj osobný profil, za ktorý je zodpovedný. 

- `/teachers/komensky`": Stránka s profilom pedagóga
- `/teachers/komensky/bp2020`: Stránka s bakalárskymi prácami pedagóga

Študenti sú organizovaní do skupín podľa roku nástupu na štúdium:

- `/students/2016/ab123cd`:  Stránka s profilom študenta a prácami na ktorých pracoval.


## Ako upravím stránky cez webové rozhranie

Prihláste sa na katedrový systém GIT. Vyhľadajte repozitár [KEMT/zpwiki](https://git.kemt.fei.tuke.sk/KEMT/zpwiki). Do tohto repozitára môžte vykonávať zmeny pomocou webového editora, kotrý Vám uľahčí prácu s formátom Markdown.


Cez webové rozhranie nájdite adresár, ktorý patrí k stránke. Ťuknite na súbor `README.md`. V pravom hornom rohu  ťuknite na ikonku s perom. Otvorí sa Vám editor v ktorom môžte upravovať. 
Keď skončíte s úpravami, ťuknite na zelené tlačítko "Commit changes/Potvrď zmeny" celkom dole na stránke. Pre vytvorenie nového adresára stačí dopísať jeho meno pred názov nového súboru a adresár sa vytvorí automaticky.

## Ako upravím stránky pomocu môjho textového editora

Ak chcete upravovať pomocou Vášho textového editora, vytvorte si lokálnu kópiu repozirára. Použite grafický GIT klient, ktorý je súčasťou Vášho editora alebo pomocou príkazu `git clone` .
Ak kópiu už máte vytvorenú, získajte najnovšie zmeny príkazom `git pull`.

V Vašou kópiou môžte vykonávať bežné operácie so súbormi a adresármi - úpravu, premiestnenie alebo vymazanie. Nájdite alebo vytvorte vhodný adresár, a upravte  súbor `README.md`, do adresára skopírujte obrázky a iné súbory. Stránka sa bude volať rovnako ako adresár. 

Na konci pridajte zmenené súbory príkazom  `git add` a potvrďte zmeny príkazom `/git commit`. Zmeny odošlite príkazom `git push`.


## Čo je to Markdown?

Markdown je jednoduchý značkovací formát obyčajného textu ktorý sa dá ľahko premeniť na HTML alebo aj iné formáty.

- [Krátky prehľad syntaxe](https://commonmark.org/help/)
- [Viac informácií o Markdown](https://www.markdownguide.org/getting-started)

Text vo formáte Markdown vytvoríte pomocou textového editora alebo pomocou webového editora, ale môžte využiť aj špecializované nástroje:

- [Dillinger](https://dillinger.io/), online Markdown Editor
- Online nástroj na [konverziu DOC](https://word2md.com/)
- [Pandoc](https://pandoc.org/) (konverzia z a do Markdown)


## Ako vytvorím odkaz

Meno stránky je totožné s adresárom v ktorom sa nachádza. Na stránku sa odkážete podobne ako na adresár v ktorom sa nachádza.
Napr. odkaz na stránku s Vašim projektom zo stránky predmetu `/teachers/hladek/bp2020`:

    [Text odkazu](../../students/ab123cd/bp)

## Ako vložím obrázok

Uložte súbor s obrázkom do adresára s Vašou stránkou. Do textu pridajte odkaz na obrázok a pridajte výkričník:

    ![Text odkazu](./obrazok.jpg)

## Čo ak som našiel preklep?

Môžte ho sám opraviť.
